﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Editors;
using System.Windows.Markup;
using Infragistics.Windows.DataPresenter;
using System.Xml;
using System.IO;

namespace testGridComboBox
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        XamComboEditor ce;
        XamTextEditor te;
        public Window1()
        {
            InitializeComponent();

            ComboBoxItemsProvider statusProvider = this.xamDG.TryFindResource("StatusItemsProvider") as ComboBoxItemsProvider;
            if (statusProvider != null)
            {
                statusProvider.ItemsSource = new ComboBoxDataItem[]
                {
                    new ComboBoxDataItem(ProgressState.Ready, "Ready"),
                    new ComboBoxDataItem(ProgressState.InProgress, "In Progress"),
                    new ComboBoxDataItem(ProgressState.PendingCompletion, "Pending Completion"),
                    new ComboBoxDataItem(ProgressState.Complete, "Complete")
                };
                ComboBoxDataItem a = new ComboBoxDataItem();
            }

            base.DataContext = new Task[]
            {
                new Task
                {
                    Name="Deliver Payload",
                    State = ProgressState.Ready,
                    PriorityLevel = 0
                },
                new Task
                {
                    Name="Initialize Instruments",
                    State = ProgressState.Complete,
                    PriorityLevel = 2
                },
                new Task
                {
                    Name="Analyze Heat Sensor Log",
                    State = ProgressState.InProgress,
                    PriorityLevel = 2
                },
                new Task
                {
                    Name="Report Temperature Readings",
                    State = ProgressState.PendingCompletion,
                    PriorityLevel = 1
                }
            };
        }


        public class Task
        {
            public string Name { get; set; }
            public int PriorityLevel { get; set; }
            public ProgressState State { get; set; }
        }

        public enum ProgressState
        {
            Complete,
            InProgress,
            PendingCompletion,
            Ready
        }

        private void XamComboEditor_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            DataRecord dr = xamDG.ActiveRecord as DataRecord;
            if (xamDG.ActiveRecord != null)
            {
                string value = ce.Value.ToString();
                te.Text = value;
            }
        }

        private void xamDG_RecordActivated(object sender, Infragistics.Windows.DataPresenter.Events.RecordActivatedEventArgs e)
        {
            DataRecord dr = xamDG.ActiveRecord as DataRecord;

            CellValuePresenter cvpCombo = CellValuePresenter.FromRecordAndField(dr, dr.FieldLayout.Fields[1]);
            CellValuePresenter cvpText = CellValuePresenter.FromRecordAndField(dr, dr.FieldLayout.Fields[0]);

            ce = cvpCombo.Editor as XamComboEditor;
            te = cvpText.Editor as XamTextEditor;
        }
    }
}
